/**
 ** MarchaPodium.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

public class MarchaPodium {

	public static final int MARCHANDO = 0;
	public static final int FINAL = 1;
	
	public static final int pasos_max[] = {19, 15, 24, 28};

	public int njg;                   /* numero de jugadores */
	public int color[] = new int[4];  /* color del 1º al 4º */
	public int tipo[] = new int[4];;  /* humano o robot */
	public int lugar[] = new int[4];  /* marchando o final */
	public int paso[] = new int[4];   /* n.paso si marchando */
	public boolean fin;               /* marcha finalizada */
	
	private int bicho_marchando;
	
	public MarchaPodium(EstadoPartida mEP) {
		fin = false;
		njg = 0;
		for (int c=EstadoPartida.AMAR; c<=EstadoPartida.VERD; c++) {
			int k = mEP.ha_terminado[c];
			if (k < 0 || k > 3) continue;
			color[k] = c;
			tipo[k] = mEP.tipo_jugador[c];
			lugar[k] = MARCHANDO;
			paso[k] = k;
			njg++;
		}
		bicho_marchando = njg - 1;
		if (njg == 0) fin = true;
	}
	
	public boolean avanza() {
		if (fin) return true;
		paso[bicho_marchando]++;
		if (paso[bicho_marchando] >= pasos_max[bicho_marchando]) {
			lugar[bicho_marchando] = FINAL;
			bicho_marchando--;
		}
		if (bicho_marchando < 0) fin = true;
		return fin;
	}
}
